#include <bits/stdc++.h>
using namespace std;
const int N=1e6+5;
long long n,q,w,m,a[N],mx;
long double r,x;
pair <long long, long double> l[N];
int main()
{
    q=1;
    w=1;
    cin >> n >> m >> r;
    for(int i=1; i<=n; i++){
        cin >> l[i].first >> l[i].second;
    }
    sort(l+1,l+n+1);
    for(int i=1; i<=m; i++){
        cin >> a[i];
    }
    for(int i=1; i<=a[m]; i++){
        x*=1.0-r;
        if(i==l[q].first){
            x+=l[q].second*r;
            q++;
        }
        if(i==a[w]){
            cout << fixed << setprecision(6) << x << " ";
            w++;
        }
    }
}
